package com.mediahub.controller;

import com.mediahub.JsonCustomMapping;
import com.mediahub.MovieService;
import com.mediahub.MovieServiceTrait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;


@RestController
@RequestMapping("/api")
public class MovieController {
    @Autowired
    MovieServiceTrait movieServiceTrait;

    @GetMapping("/teamMembers")
    public ResponseEntity getTeamMembers(@RequestParam(required = true) String movieTitle) {
        scala.collection.immutable.List<MovieService.Principal> principalList;

        try {
            if (movieTitle == null)
                return new ResponseEntity<>(null, HttpStatus.BAD_REQUEST);
            else {
                principalList = (movieServiceTrait.principalsForMovieName(movieTitle).toList());
            }

            return new ResponseEntity<>(new JsonCustomMapping().mapperPrincipal(principalList), HttpStatus.OK);

        } catch (Exception e) {
            return new ResponseEntity<>(null, HttpStatus.INTERNAL_SERVER_ERROR);
        }

    }

    @GetMapping("/tvSeries")
    public ResponseEntity getTvSeries() {
        scala.collection.immutable.List<MovieService.TvSeries> tvSeriesList;

        try {
            tvSeriesList = (movieServiceTrait.tvSeriesWithGreatestNumberOfEpisodes().toList());
            return new ResponseEntity<>(new JsonCustomMapping().mapperSeries(tvSeriesList), HttpStatus.OK);
        } catch (Exception e) {
            return new ResponseEntity<>(null, HttpStatus.INTERNAL_SERVER_ERROR);
        }

    }

}